import sys
import paramiko
import json
import configparser
import os
import subprocess
import time
sys.path.append('/certs/common')
sys.path.append('../')
from runlogger import *
from os import path

def execreboot():
    esx_host = getenvdata('/','esx','hostname')[0]
    esx_user = getenvdata('/','esx','user')[0]
    esx_password = getenvdata('/','esx','password')[0]
    logging.info(esx_host)
    ssh = sshConnection(esx_host,esx_user,esx_password)
    stdin, stdout, stderr = ssh.exec_command("reboot")
    time.sleep(300)
    tries = 3
    #after reboot try 3 times to check whether the system is up 
    while(tries >= 0):
       try:
           ssh = sshConnection(esx_host,esx_user,esx_password)
           return True
       except:
           time.sleep(300)
           tries = tries - 1
    return False

def isloadESXcheck(certinfo_dir):
    logging.info("executing isloadesx check")
    certinfo_file = certinfo_dir+'/certInfo.properties'
    logging.info(certinfo_file)
    esx_host = getenvdata('/','esx','hostname')[0]
    esx_user = getenvdata('/','esx','user')[0]
    esx_password = getenvdata('/','esx','password')[0]
    ssh = sshConnection(esx_host,esx_user,esx_password)
    f = open(certinfo_file,'a+',encoding = 'utf-8')
    num_reboot = 2
    #repeat quickboot twice if host booting with loadESX correctly
    while num_reboot >0:
        #enable loadesx
        stdin, enable_loadesx, stderr = ssh.exec_command("/bin/loadESXEnable -e -i")
        logging.info(enable_loadesx.readline())
        execreboot()
        ssh = sshConnection(esx_host,esx_user,esx_password)
        stdin, bootdone, stderr = ssh.exec_command("vsish -e get /system/bootDone")
        stdin, isloadesx, stderr = ssh.exec_command("vsish -e get /system/loadESX/isBootLoadESX")
        if isloadesx == 0 or bootdone == 0:
            break
        elif isloadesx == 1 and bootdone == 1:
            logging.info("Doing next reboot")
        num_reboot = num_reboot - 1
    logging.info("load esx values after reboot...")
    bootdone_res = bootdone.readline().rstrip()
    loadesx_res = isloadesx.readline().rstrip()
    logging.info("Value of isbootdone and isloadesx are %s %s", bootdone_res, loadesx_res)
    if(bootdone_res == str(1) and loadesx_res == str(1)):
        f.write("isBootLoadESX=true\n")
    else:
        f.write("isBootLoadESX=false\n")
    ssh.close()
    f.close()

def sshConnection(esx_host,esx_user,esx_password):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.connect(hostname=esx_host, username=esx_user, password=esx_password)
    return ssh
def getenvdata(dir, hosttype,key):
    with open(dir+'runlist.json') as json_data:
        data = json.load(json_data)
        return  [ li[key] for li in data['environment']['hosts'] if li['hosttype'] == hosttype]

def main():
    runlogger(sys.argv[2])
    isloadESXcheck(sys.argv[1])
if __name__== '__main__':
    main()

