#!/bin/bash

. ../common/launcher.sh

logdir=$(getLogDir)

filepath=$(cd $logdir;cd ../../;pwd)

hostname=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["environment"]["hosts"][0]["hostname"])')
user=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["environment"]["hosts"][0]["user"])')
password=$(cat /runlist.json | python3 -c 'import json,sys;obj=json.load(sys.stdin);print(obj["environment"]["hosts"][0]["password"])')
cat /dev/null > $filepath/certInfo.properties
sshpass -p $password scp -o stricthostkeychecking=no ${0%/*}/getCPUSteppingMicrocodes.sh $user@$hostname:/
sshpass -p $password ssh -o stricthostkeychecking=no $user@$hostname sh /getCPUSteppingMicrocodes.sh >> $filepath/certInfo.properties

testname=$(getTestCaseName)

if [ "$testname" == "VM_Support_Log_Collection" ]
then
    python3 /certs/common/isloadesxcheck.py $filepath $(getLogDir)
    python3 /certs/common/bios_info.py $filepath
fi

python3 $1 "$testname" $(getLogDir) $2

